<?php

/* * ********************************************************************
 *  Provisioning Module for NodePing. Custom developed.
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Bogusław Kotarski <boguslaw.ko@modulesgarden.com>
 */
class NodePingHelpers {

    public static function contactToArray($addresses, $name, &$members) {


        foreach ($addresses as $contactID => $contact) {

            if (!isset($contact->address)) {
                $contact->address = '';
            }

            if (!isset($contact->status)) {
                $contact->status = '';
            }

            if (!isset($contact->accountsuppressall)) {
                $contact->accountsuppressall = '';
            }

            if (!isset($contact->type)) {
                $contact->type = '';
            }

            $members[$contactID] = array(
                'address'            => $contact->address,
                'type'               => $contact->type,
                'status'             => $contact->status,
                'accountsuppressall' => $contact->accountsuppressall,
                'name'               => $name
            );
        }

        return $members;

    }

    public static function contactToList($addresses) {

        $return = array();

        foreach ($addresses as $row) {

            if (!isset($row->address)) {
                $row->address = '';
            }

            if (!isset($row->status)) {
                $row->status = '';
            }

            if (!isset($row->accountsuppressall)) {
                $row->accountsuppressall = '';
            }

            if (!isset($row->type)) {
                $row->type = '';
            }

            $return['address'][]            = $row->address;
            $return['status'][]             = $row->status;
            $return['accountsuppressall'][] = $row->accountsuppressall;
            $return['type'][]               = $row->type;
        }

        return $return;

    }

    public static function contactToTable($result) {

        $contactsTable = array();

        foreach ($result as $contactID => $contact) {

            if (!isset($contact->name)) {
                $contact->name = '';
            }

            if (isset($contact->addresses)) {
                $addresses       = self::contactToList($contact->addresses);
                $address         = implode('<br/>', $addresses['address']);
                //$status          = implode('<br/>', $addresses['status']);
                $type            = implode('<br/>', $addresses['type']);
                $contactsTable[] = array(
                    'name'    => $contact->name,
                    'type'    => $type,
                    'address' => $address,
                    'id'      => $contactID);
            }
        }

        return $contactsTable;

    }

    public static function groupsToArray($result) {

        $groups = array();

        foreach ($result as $groupID => $group) {

            if (!isset($group->name)) {
                $group->name = '';
            }

            $groups[$groupID] = array('name' => $group->name, 'id' => $groupID);
        }

        return $groups;

    }

    public static function contactsToArray($result) {

        $members = array();

        foreach ($result as $contactID => $contact) {
            if (isset($contact->addresses)) {
                if (!isset($contact->name)) {
                    $contact->name = '';
                }
                self::contactToArray($contact->addresses, $contact->name, $members);
            }
        }

        return $members;

    }

    public static function getContactsCount($result) {

        $count = 0;

        foreach ($result as $contact) {
            $count++;
        }
        return $count;

    }

    public static function contactToMembersArray($result, $contactList) {

        $return = array();

        if (!isset($result->name)) {
            $result->name = '';
        }

        if (isset($result->members)) {
            foreach ($result->members as $contactID) {
                $return[] = array(
                    'id'      => $contactID,
                    'name'    => $contactList[$contactID]['name'],
                    'type'    => $contactList[$contactID]['type'],
                    'address' => $contactList[$contactID]['address']);
            }
        }

        return $return;

    }

    public static function contactsToNotificationsArray($result, $contactList, $groupList) {

        $return = array();

        if (isset($result->notifications)) {
            foreach ($result->notifications as $notification) {
                foreach ($notification as $contactID => $notificationTime) {
                    if (isset($contactList[$contactID])) {
                        $return[] = array(
                            'id'       => $contactID,
                            'time'     => $notificationTime,
                            'name'     => $contactList[$contactID]['name'],
                            'type'     => $contactList[$contactID]['type'],
                            'address'  => $contactList[$contactID]['address'],
                            'mainType' => 'contact'
                        );
                    }

                    if (isset($groupList[$contactID])) {
                        $return[] = array(
                            'id'       => $contactID,
                            'time'     => $notificationTime,
                            'name'     => $groupList[$contactID]['name'],
                            'mainType' => 'group'
                        );
                    }
                }
            }
        }

        return $return;

    }

    public static function contactsToMembersText($result, $contactList) {

        $return      = array();
        $contactList = self::contactToMembersArray($result, $contactList);

        foreach ($contactList as $contact) {
            $return[] = array(
                'text' => $contact['name'] . ' - ' . $contact['type'] . ' - ' . $contact['address'],
                'id'   => $contact['id']
            );
        }

        return $return;

    }

    public static function contactsToNotificationsText($result, $contactList, $groupList) {

        $return      = array();
        $contactList = self::contactsToNotificationsArray($result, $contactList, $groupList);

        foreach ($contactList as $contact) {
            if ($contact['mainType'] == 'contact') {
                $text = $contact['name'] . ' - ' . $contact['type'] . ' - ' . $contact['address'];
            } else {
                $text = $contact['name'];
            }
            $return[] = array(
                'text' => $text,
                'id'   => $contact['id'],
                'time' => $contact['time']
            );
        }

        return $return;

    }

    public static function groupName($result) {
        if (isset($result->name)) {
            return $result->name;
        } else {
            return '';
        }

    }

    public static function checksToArray($result) {

        $checks = array();

        foreach ($result as $checkID => $check) {

            if (!isset($check->type)) {
                $check->type = '';
            }

            if (!isset($check->label)) {
                $check->label = '';
            }

            if (!isset($check->interval)) {
                $check->interval = '';
            }

            if (!isset($check->enable)) {
                $check->enable = '';
            }

            $checks[] = array(
                'enable'   => $check->enable,
                'type'     => $check->type,
                'label'    => $check->label,
                'interval' => $check->interval,
                'id'       => $checkID
            );
        }
        return $checks;

    }

    public static function checksToPOST($result, &$POST) {

        if (isset($result->notifications)) {
            foreach ($result->notifications as $notification) {
                foreach ($notification as $notificationID => $notificationTime) {
                    $POST['$notification'][] = array('id' => $notificationID, 'time' => $notificationTime);
                }
            }
        }

        if (isset($result->label)) {
            $POST['label'] = $result->label;
        } else {
            $POST['label'] = '';
        }

        if (isset($result->enable)) {
            if ($result->enable == 'active') {
                $POST['enabled'] = 'true';
                if (isset($result->uuid)) {
                    $POST['uuid'] = $result->uuid;
                }
            } else {
                $POST['enabled'] = 'false';
            }
        } else {
            $POST['enabled'] = 'false';
        }

        if (isset($result->description)) {
            $POST['description'] = $result->description;
        } else {
            $POST['description'] = '';
        }

        if (isset($result->public)) {
            if ($result->public == 1) {
                $POST['public'] = 'true';
            } else {
                $POST['public'] = 'false';
            }
        } else {
            $POST['public'] = 'false';
        }

        if (isset($result->runlocations[0])) {
            $POST['runlocations'] = $result->runlocations[0];
        }

        if (isset($result->interval)) {
            $POST['interval'] = $result->interval;
        } else {
            $POST['interval'] = '';
        }

        if (isset($result->uuid)) {
            $POST['uuid'] = $result->uuid;
        }

        if (isset($result->parameters)) {
            foreach ($result->parameters as $name => $value) {
                $POST['param_' . $name] = $value;
            }
        }

        if (isset($result->parameters->fields)) {
            foreach ($result->parameters->fields as $field) {
                $POST['param_fields2'][] = array('name' => $field->name, 'min' => $field->min, 'max' => $field->max,);
            }
        }

        if (isset($result->parameters->sendheaders)) {
            foreach ($result->parameters->sendheaders as $key => $field) {
                $POST['param_sendheaders2'][$key] = $field;
            }
        }

        if (isset($result->parameters->receiveheaders)) {
            foreach ($result->parameters->receiveheaders as $key => $field) {
                $POST['param_receiveheaders2'][$key] = $field;
            }
        }

        if (isset($result->parameters->data)) {
            foreach ($result->parameters->data as $key => $field) {
                $POST['param_data2'][$key] = $field;
            }
        }

    }

    public static function groupsToPOST($result, &$POST) {

        if (isset($result->name)) {
            $POST['contactName'] = $result->name;
        } else {
            $POST['contactName'] = '';
        }

        if (isset($result->custrole)) {
            $POST['contactLevel'] = $result->custrole;
        } else {
            $POST['contactLevel'] = '';
        }

        if (isset($result->_id)) {
            $POST['contactID'] = $result->_id;
        } else {
            $POST['contactID'] = '';
        }

        if (isset($result->addresses)) {
            foreach ($result->addresses as $id => $row) {
                if (isset($row->address)) {
                    $address = $row->address;
                } else {
                    $address = '';
                }
                if (isset($row->type)) {
                    $type = $row->type;
                } else {
                    $type = '';
                }
                $POST['contacts'][] = array('value' => $address, 'type' => $type, 'id' => $id);
            }
        }

    }

    public static function checkResultToArray($result, &$POST) {

        foreach ($result as $key => $checkResult) {

            $location = array();

            foreach ($checkResult->l as $l) {
                $location[] = $l;
            }

            $response = $checkResult->sc;
            if ($response == 'Error') {
                $response .= ' / ' . htmlspecialchars($checkResult->m);
            }

            if(!isset($checkResult->su)){
                $result =  'N/A';
            }else if ($checkResult->su) {
                $result = 'PASS';
            } else {
                $result = 'FAIL';
            }

            $ts                     = date('Y-m-d H:i:s', $checkResult->s / 1000);
            $POST['checkResults'][] = array(
                'time'     => $ts,
                'location' => implode(', ', $location),
                'runtime'  => $checkResult->rt,
                'response' => $response,
                'result'   => $result,
            );
        }

    }

    public static function getLastCheckResultStatus($result) {
        if ($result) {
            foreach ($result as $key => $checkResult) {
                if ($checkResult->su) {
                    return 'PASS';
                }else if(!isset($checkResult->su)){
                    return 'N/A';
                }else {
                    return 'FAIL';
                }
            }
        } else {
            return '-';
        }

    }

}
